<?php
/**
* joomla_lms.course_users.html.php
* (c) JoomaLMS eLearning Software http://www.joomlalms.com/
**/

// no direct access
defined( '_JLMS_EXEC' ) or die( 'Restricted access' );

class JLMS_course_users_html {
	
	static function showUserGroups( $course_id, $option, &$rows, &$lists ) {
		$JLMS_CONFIG = JLMSFactory::getConfig();
		$JLMS_ACL = JLMSFactory::getACL();		
		$Itemid = $JLMS_CONFIG->get('Itemid');
		
		$link_new = "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=new_usergroup&amp;id=".$course_id;
		$link_csvdelete = "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=user_csv_delete&amp;id=".$course_id;
		
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => _JLMS_USERGROUPS_TITLE, 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();
		
		if ($JLMS_ACL->CheckPermissions('users', 'manage')) {		
			$toolbar->addNewButton(array('href' => sefRelToAbs($link_new), 'title' => _JLMS_USER_ALT_NEWGROUP));		
			
			$exportBtn	= $toolbar->addExportButton(array('title' => _JLMS_USER_ALT_EXPGROUP));			
			$exportBtn->addExportItem(array('href' => "javascript:submitbutton('export_usergroup');", 'title' => 'csv'));		
			
			$actionsBtn	= $toolbar->addActionsButton();			
			$actionsBtn->addDeleteItem(array('href' => "javascript:submitbutton('usergroup_delete');", 'title' => _JLMS_USER_ALT_DELGROUP));			
			
			$toolbar->addDeleteButton(array('href' => ampReplace(sefRelToAbs($link_csvdelete)), 'title' => _JLMS_USERS_CSV_DELETE));
		}		
		echo $contentHeader;
		echo $toolbar;		
		?>
		<script language="javascript" type="text/javascript">
		<!--
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if ( ((pressbutton == 'edit_usergroup') || (pressbutton == 'export_usergroup')) && (form.boxchecked.value == '0')) {
				alert('<?php echo _JLMS_ALERT_SELECT_ITEM;?>');
			} else if ((pressbutton == 'usergroup_delete') && (form.boxchecked.value == '0')) {
				alert('<?php echo _JLMS_ALERT_SELECT_ITEM;?>');
			} else {
				form.task.value = pressbutton;
				form.submit();
			}
		}
		//-->
		</script>		
		<form action="<?php echo $JLMS_CONFIG->get('live_site')."/index.php?option=".$option."&amp;Itemid=".$Itemid;?>" method="post" id="adminForm" name="adminForm">
			<table width="100%" class="table table-striped table-hover">
				<tr>
					<th width="20" align="center">#</th>
					<?php
					if ($JLMS_ACL->CheckPermissions('users', 'manage')){
					?>
					<th width="1%" colspan="2" align="center"><input type="checkbox" name="toggle" value="" onclick="<?php echo JLMS_getCheckAll(count($rows));?>" /></th>
					<?php
					} 
					?>
					<th><?php echo _JLMS_USERS_TBL_HEAD_GROUPNAME;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_GROUPDESCR;?></th>
				</tr>
				<?php if ($JLMS_ACL->CheckPermissions('users', 'manage_teachers')) { ?>
				<tr>
					<td align="center">-</td>
					<td colspan="2" align="center">&nbsp;</td>
					<td><?php $link = "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_assistants&amp;id=".$course_id; ?>
						<a href="<?php echo sefRelToAbs($link);?>" title="<?php echo _JLMS_USERS_GROUP_LINK_TITLE;?>">
							<?php echo _JLMS_TEACHER_ASSISTANTS;?>
						</a>
					</td>
					<td><?php echo _JLMS_USER_ASSIST_GROUP_DESCR;?></td>
				</tr>
			<?php } ?>
			<?php if ($lists['no_group']) { ?>
				<tr>
					<td align="center">-</td>
					<?php if ($JLMS_ACL->CheckPermissions('users', 'manage')) { ?>
					<td colspan="2" align="center"><?php echo mosHTML::idBox( 0, 0); ?></td>					
					<?php } ?>
					<td><?php $link = "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_users&amp;course_id=".$course_id."&amp;group_id=0"; ?>
						<a href="<?php echo sefRelToAbs($link);?>" title="<?php echo _JLMS_USERS_GROUP_LINK_TITLE;?>">
							<?php echo _JLMS_USER_NO_GROUP_NAME;?>
						</a>
					</td>
					<td><?php echo _JLMS_USER_ASSIST_GROUP_DESCR;?></td>
				</tr>
			<?php }
			$k = 1;
			for ($i=0, $n=count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$link = "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_users&amp;course_id=".$course_id."&amp;group_id=". $row->id;
				$checked = mosHTML::idBox( $i+1, $row->id);
				if (!$JLMS_ACL->CheckPermissions('users', 'manage')) {
					$checked = '&nbsp;';	
				}
				?>
				<tr>
					<td align="center"><?php echo ( $i + 1 ); ?></td>
					<?php if ($JLMS_ACL->CheckPermissions('users', 'manage')) { ?>
					<td width="1%"><?php echo $checked; ?></td>
					<td width="1%">
						<?php						
						$itemToolbar = new \LMS\Widgets\Button(
							array(
								'type' => 'dropdown',
								'class' => 'btn-micro'								
							)
						);
						$itemToolbar->addEditItem( array('href' => 'javascript:listItemTask(\'cb'.($i+1).'\', \'edit_usergroup\')') );
						$itemToolbar->addDeleteItem( array('href' => 'javascript:listItemTask(\'cb'.($i+1).'\', \'usergroup_delete\')') );
						echo $itemToolbar;
						?>
					</td>
					<?php } ?>
					<td align="left">
						<a href="<?php echo sefRelToAbs($link);?>" title="<?php echo _JLMS_USERS_GROUP_LINK_TITLE;?>">
							<?php echo $row->ug_name;?>
						</a>
					</td>
					<td><?php echo $row->ug_description;?></td>
				</tr>
				<?php
				$k = 3 - $k;
			}?>
			</table>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="course_users" />
			<input type="hidden" name="id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="row_id" value="0" />
			<input type="hidden" name="state" value="0" />
		</form>
<?php		
	}

	static function showDeleteUsersCSV( $course_id, $option ) {
		global $Itemid;
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		$form = JForm::getInstance('usersdeletecsv', 'usersdeletecsv');
		
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => _JLMS_USERS_CSV_DELETE, 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();	
		
		$toolbar->addDeleteButton(array('href' => "javascript:Joomla.submitbutton('import_csv_delete');"));
		$toolbar->addCancelButton(array('href' => "javascript:Joomla.submitbutton('cancel_csv_delete');"));
	
		echo $contentHeader;
		echo $toolbar;
		
		JHtml::_('behavior.formvalidation');						
		?>
		<script type="text/javascript">
			Joomla.submitbutton = function(task)
			{
				var form = document.adminForm;
				if (task == 'cancel_csv_delete' || document.formvalidator.isValid(form))
				{
					Joomla.submitform(task, form);
				}
			}
		</script>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid");?>" method="post" id="adminForm" name="adminForm" class="form-validate" enctype="multipart/form-data">
			<div class="form-horizontal">
				<div class="row-fluid">
					<?php foreach ($form->getFieldset('base') as $field) : ?>
						<div class="control-group">
							<div class="control-label">
								<?php echo $field->label; ?>
							</div>
							<div class="controls">
								<?php echo $field->input; ?>
							</div>
						</div>
					<?php endforeach; ?>
				</div>
			</div>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="csv_delete_users" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
		</form>
<?php
	}

	static function editUserGroup($row, $course_id ) 
	{
		global $Itemid;
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		$form = JForm::getInstance('usergroup', 'usergroup');
		
		$form->bind($row);
		
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => (int)$form->getValue('id') ? _JLMS_USERGROUP_EDIT_TITLE : _JLMS_USERGROUP_NEW_TITLE, 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();	
		
		$toolbar->addSaveButton(array('href' => "javascript:Joomla.submitbutton('save_usergroup');"));
		$toolbar->addCancelButton(array('href' => "javascript:Joomla.submitbutton('cancel_usergroup');"));
	
		echo $contentHeader;
		echo $toolbar;
		
		JHtml::_('behavior.formvalidation');
						
		?>
		<script type="text/javascript">
			Joomla.submitbutton = function(task)
			{
				var form = document.adminForm;
				if (task == 'cancel_usergroup' || document.formvalidator.isValid(form))
				{
					<?php echo $form->getField('ug_description')->save(); ?>
					Joomla.submitform(task, form);
				}
			}
		</script>
		<form action="<?php echo sefRelToAbs("index.php?option=com_joomla_lms&amp;Itemid=$Itemid&amp;");?>" method="post" id="adminForm" name="adminForm" class="form-validate">
			<div class="form-horizontal">
				<div class="row-fluid">
					<?php foreach ($form->getFieldset('details') as $field) : ?>
						<div class="control-group">
							<div class="control-label">
								<?php echo $field->label; ?>
							</div>
							<div class="controls">
								<?php echo $field->input; ?>
							</div>
						</div>
					<?php endforeach; ?>
					<?php foreach ($form->getFieldset('hidden') as $field) : ?>
								<?php echo $field->input; ?>						
					<?php endforeach; ?>
				</div>
			</div>
		</form>
	<?php		
	}

/*	Show users in group
	$view_type == 1 - show users from usergroup
	$view_type == 2 - show teacher assistants */
	static function showUsers( $course_id, $group_id, $option, &$rows, &$lists, &$pageNav, $u_search, $view_type = 1, $groupName = '' ) {	
		global $Itemid, $task;
		$JLMS_CONFIG = JLMSFactory::getConfig();
		$JLMS_ACL = JLMSFactory::getACL();	
?>
<script language="javascript" type="text/javascript">
<!--
function submitbutton(pressbutton) {
	var form = document.adminForm;
	if ((pressbutton == 'edit_user' || pressbutton == 'delete_user') && (form.boxchecked.value == "0")){
		alert( "<?php echo _JLMS_USER_SELECT_USER;?>" );
	} else {
		form.task.value = pressbutton;		
		form.submit();
	}
}
//-->
</script>
<?php		

		$toolbar = array();
		$title = '';
		
		
		if ($view_type == 1) {
			$title = '&nbsp;'._JLMS_USERS_TITLE.(isset($groupName)?(" (".$groupName.")"):'('.JText::_('_JLMS_USER_NO_GROUP_NAME').')');
		} elseif ($view_type == 2) {
			$title = '&nbsp;'._JLMS_TEACHER_ASSISTANTS;
		}		
		
		$link_add = $JLMS_CONFIG->get('live_site')."/index.php?option=".$option."&amp;task=add_user&amp;course_id=".$course_id."&amp;group_id=".$group_id."&amp;Itemid=".$Itemid."";
		$link_import = $JLMS_CONFIG->get('live_site')."/index.php?option=".$option."&amp;task=import_users_csv&amp;course_id=".$course_id."&amp;group_id=".$group_id."&amp;Itemid=".$Itemid."";
		
		if ($view_type == 2) {
			$link_add .= '&amp;utype=2';
			$link_import .= '&amp;utype=2';
		}
		
		if ($view_type == 1) {
			$pagNavLink = "index.php?option=$option&amp;Itemid=$Itemid&amp;task=view_users&amp;course_id=$course_id&amp;group_id=$group_id";
		} else {
			$pagNavLink = "index.php?option=$option&amp;Itemid=$Itemid&amp;task=view_assistants&amp;id=$course_id";
		}
		
		if($u_search != ''){
			$pagNavLink .= '&amp;u_search='.$u_search;
		}							
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		
		$filtersForm = JForm::getInstance('filters', 'filters');
				
		$filtersForm->bind(array('u_search' => $u_search, 'filt_group' => $group_id));
		
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => $title, 'icon' => 'users_management'));
		$contentTabs	= new \LMS\Widgets\Tabs();
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$filters = new \LMS\Widgets\Filters();
		
		$filters->addFilter($filtersForm->getField('u_search'));		
		$filters->addFilter($pageNav->getLimitBox( $pagNavLink ));
		
		if ($view_type == 1) {		
			$filters->addFilter($filtersForm->getField('filt_group'));
		}		
				
		if($JLMS_ACL->CheckPermissions('users', 'manage')){	
			$toolbar->addNewButton(array('href' => $link_add, 'title' => _JLMS_USER_ALT_ADDUSER));
			
			$actionsBtn	= $toolbar->addActionsButton();			
			$actionsBtn->addDeleteItem(array('href' => "javascript:submitbutton('delete_user');", 'title' => _JLMS_USER_ALT_DELUSER));			
			
			$toolbar->addImportButton(array('href' =>  $link_import, 'title' => _JLMS_USER_IMPORT_TITLE));			
		}
		
		if ($view_type == 1) {		
			$contentTabs->addTab(array('href' => "javascript:submitbutton('view_users');", 'title' => _JLMS_USERS, 'icon'=>'users', 'active' => true));		
			$contentTabs->addTab(array('href' => "javascript:submitbutton('view_assistants');", 'title' => _JLMS_USER_ASSIST_GROUP_NAME, 'icon'=>'users'));
		} else {
			$contentTabs->addTab(array('href' => "javascript:submitbutton('course_users');", 'title' => _JLMS_USERS, 'icon'=>'users'));		
			$contentTabs->addTab(array('href' => "javascript:submitbutton('view_assistants');", 'title' => _JLMS_USER_ASSIST_GROUP_NAME, 'icon'=>'users', 'active' => true));
		}
	
		echo $contentHeader;
		echo $contentTabs;
		echo $toolbar;
		
		$colspan = $view_type==1 ? 7 : 6;
		$isAdmin = $JLMS_ACL->isAdmin();		
?>
		<form action="<?php echo $JLMS_CONFIG->get('live_site') ."/index.php?option=".$option."&amp;Itemid=".$Itemid;?>" method="post" id="adminForm" name="adminForm">
			<?php echo $filters; ?>
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover">
				<tr>
					<th width="1%" align="center">#</th>
					<?php	
					$view_checkbox = 0;
					
					if($view_type == 1){						
						$view_checkbox = 1;
					} else {
						$view_checkbox = 0;
						foreach($rows as $row){
							if($row->roletype_id == 5){
								$view_checkbox = 1;
								break;
							}
						}
					}					
					
					
					if ($JLMS_ACL->CheckPermissions('users', 'manage') && $view_checkbox) {
					?>
					<th width="1%" colspan="2" align="center"><input type="checkbox" name="toggle" value="" onclick="<?php echo JLMS_getCheckAll(count($rows));?>" /></th>
					<?php
					} 
					?>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USERNAME;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_ADDINFO;?></th>
					<th><?php echo _JLMS_TBL_HEAD_USERS_ROLE;?></th>
				<?php if ($view_type == 1) { ?>
					<th colspan="2" align="center"><?php echo _JLMS_USERS_TBL_HEAD_USER_ACC_PERIOD;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_COMMENT;?></th>
				<?php } else { ?>

				<?php } ?>
				</tr>
			<?php
			$k = 1;
			
			for ($i=0, $n=count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$link 	= "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_users&amp;course_id=".$course_id."&amp;id=". $row->id;
				$checked = mosHTML::idBox( $i, $row->id);				
				
				$itemToolbar = new \LMS\Widgets\Button(
					array(
						'type' => 'dropdown',
						'class' => 'btn-micro'								
					)
				);
				if($view_type == 1) {
					$itemToolbar->addEditItem( array('href' => 'javascript:listItemTask(\'cb'.$i.'\', \'edit_user\')') );
				}
				$itemToolbar->addDeleteItem( array('href' => 'javascript:listItemTask(\'cb'.$i.'\', \'delete_user\')') );						
			
				if (!$JLMS_ACL->CheckPermissions('users', 'manage')) {
					$checked = '&nbsp;';
					$itemToolbar = '&nbsp;';
				}				
				
				if($row->roletype_id == 2){ //Max: no select teachers
					$checked = '&nbsp;';
					$itemToolbar = '&nbsp;';
				}
				
				if($row->roletype_id == 5){ //Den: do not select assistants who is not in your 'roles assignments' permissions
					$ass_roles = $JLMS_ACL->GetSystemRolesIds(5, true);
					if (is_array($ass_roles) && in_array($row->role_id, $ass_roles)) {
						//ok
					} else {
						$checked = '&nbsp;';
						$itemToolbar = '&nbsp;';
					}
				}				
			?>
				<tr>
					<td align="center"><?php echo ( $pageNav->limitstart + $i + 1 );?></td>
					<?php if ($JLMS_ACL->CheckPermissions('users', 'manage') && $view_checkbox) { ?>
					<td width="1%"><?php echo $checked; ?></td>
					<td width="1%">
						<?php echo $itemToolbar; ?>
					</td>
					<?php } ?>
					<td align="left">
					<?php echo $row->username?>
					</td>
					<td><?php echo $row->name . "(".$row->email.")";?></td>
					<td><?php echo $row->lms_usertype;?></td>
					<?php if ($view_type == 1) { ?>
					<td align="center"><?php echo ($row->publish_start?JLMS_dateToDisplay($row->start_date):'-');?></td>
					<td align="center"><?php echo ($row->publish_end?JLMS_dateToDisplay($row->end_date):'-');?></td>
					<td><?php echo ($row->user_add_comment)?$row->user_add_comment:'&nbsp;';?></td>
					<?php } else { ?>

					<?php } ?>
				</tr>
				<?php
				$k = 3 - $k;
			}?>
				<tr>
					<td colspan="<?php echo (($view_type == 1)?'10':'6');?>" align="center">
						<div class="pagination" align="center" style="white-space: nowrap;">
						<?php							
							echo $pageNav->getPagesCounter();
							echo '<br />';
							echo $pageNav->writePagesLinks( $pagNavLink );
						?>
						</div>
					</td>
				</tr>
			</table>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="<?php echo $task;?>" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="group_id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="row_id" value="0" />
			<input type="hidden" name="state" value="0" />
			<input type="hidden" name="utype" value="<?php echo $view_type;?>" />
		</form>
<?php	
	}

	static function showUsersGlobal( $course_id, $group_id, $option, &$rows, &$lists, &$pageNav, $u_search, $view_type = 1 ) {
		global $Itemid, $JLMS_CONFIG; 
		$JLMS_ACL = JLMSFactory::getACL();
		?>
		<script language="javascript" type="text/javascript">
		<!--
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if ((pressbutton == 'edit_user' || pressbutton == 'delete_user') && (form.boxchecked.value == "0")){
				alert( "<?php echo _JLMS_USER_SELECT_USER;?>" );
			} else {
				form.task.value = pressbutton;
				form.submit();
			}
		}
		//-->
		</script>
		<?php	
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		
		$filtersForm = JForm::getInstance('filters', 'filters');
		$filtersForm->bind(array('u_search' => $u_search));
		
		$title = '';

		if ($view_type == 1) {
			$title = _JLMS_USERS_TITLE;
		} elseif ($view_type == 2) {
			$title = _JLMS_TEACHER_ASSISTANTS;
		}
		
		$contentHeader = new \LMS\Widgets\ContentHeader(array('title'=>$title, 'icon' => 'users_management'));		
		$contentTabs = new \LMS\Widgets\Tabs();
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$filters = new \LMS\Widgets\Filters();
		
		
		$link_add = $JLMS_CONFIG->get('live_site')."/index.php?option=".$option."&amp;task=add_user&amp;course_id=".$course_id."&amp;id=0&amp;Itemid=".$Itemid."";
		$link_import = $JLMS_CONFIG->get('live_site')."/index.php?option=".$option."&amp;task=import_users_csv&amp;course_id=".$course_id."&amp;id=0&amp;Itemid=".$Itemid."";
		if ($view_type == 2) {
			$link_add .= '&amp;utype=2';
		}		
	
		if ($JLMS_ACL->CheckPermissions('users', 'manage')) {
			$toolbar->addNewButton(array('href' => sefRelToAbs($link_add), 'title' => _JLMS_USER_ALT_ADDUSER));		
		
			$actionsBtn	= $toolbar->addActionsButton();			
			$actionsBtn->addDeleteItem(array('href' => "javascript:submitbutton('delete_user');", 'title' => _JLMS_USER_ALT_DELUSER));			
			
			if ($JLMS_ACL->CheckPermissions('users', 'import_users')) {
				$toolbar->addImportButton(array('href' => $link_import, 'title' => _JLMS_USER_IMPORT_TITLE));
			}
			
			$contentTabs->addTab(array('href' => "javascript:submitbutton('course_users');", 'title' => _JLMS_USERS, 'icon'=>'users', 'active' => true));
			$contentTabs->addTab(array('href' => "javascript:submitbutton('view_assistants');", 'title' => _JLMS_USER_ASSIST_GROUP_NAME, 'icon'=>'users'));
		}	
		
		$link = "index.php?option=$option&amp;Itemid=$Itemid&amp;task=course_users&amp;id=$course_id&amp;group_id=$group_id";
		if($u_search != ''){
			$link .= '&amp;u_search='.$u_search;
		}
	
		ob_start();
		$pageNav->writeLimitBox( $link );
		$limitBox = ob_get_contents();
		ob_end_clean();
		
		$filters->addFilter($filtersForm->getField('u_search'));
		$filters->addFilter($filtersForm->getField('group'));
		
		$filters->addFilter($limitBox);		
		$colspan = $view_type==1 ? 9 : 4;
?>
		<form action="<?php echo $JLMS_CONFIG->get('live_site') ."/index.php?option=".$option."&amp;Itemid=".$Itemid;?>" method="post" name="adminForm">
			<?php
					echo $contentHeader;					
					echo $contentTabs;
					echo $toolbar;
					echo $filters;
			?>			
			<table width="100%" class="table table-striped table-hover">
				<thead><tr>
					<th width="1%">#</th>
					<?php if ($JLMS_ACL->CheckPermissions('users', 'manage')) {	?>
					<th width="1%" colspan="2" ><input type="checkbox" name="toggle" value="" onclick="<?php /*smt*/ echo JLMS_getCheckAll(count($rows));?>" /></th>
					<?php } ?>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USERNAME;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_ADDINFO;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_GROUP;?></th>
					<th><?php echo _JLMS_TBL_HEAD_USERS_ROLE;?></th>
				<?php if ($view_type == 1) { ?>
					<th colspan="2"><?php echo _JLMS_USERS_TBL_HEAD_USER_ACC_PERIOD;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_COMMENT;?></th>
				<?php } ?>
				</tr></thead>
				<tbody>
			<?php
			$k = 1;
			for ($i=0, $n=count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$link 	= "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_users&amp;course_id=".$course_id."&amp;id=". $row->id;
				$checked = mosHTML::idBox( $i, $row->id); 
				if (!$JLMS_ACL->CheckPermissions('users', 'manage')) {
					$checked = '&nbsp;';
				}
				?>
				<tr class="<?php echo JLMSCSS::_('sectiontableentry'.$k); ?>">
					<td align="center"><?php echo ( $pageNav->limitstart + $i + 1 );?></td>
					<?php if ($JLMS_ACL->CheckPermissions('users', 'manage')) {	?>
					<td width="1%"><?php echo $checked; ?></td>
					<td width="1%">
						<?php						
						$itemToolbar = new \LMS\Widgets\Button(
							array(
								'type' => 'dropdown',
								'class' => 'btn-micro'								
							)
						);
						$itemToolbar->addEditItem( array('href' => 'javascript:listItemTask(\'cb'.$i.'\', \'edit_user\')') );
						$itemToolbar->addDeleteItem( array('href' => 'javascript:listItemTask(\'cb'.$i.'\', \'delete_user\')') );
						echo $itemToolbar;
						?>
					</td>
					<?php } ?>
					<td align="left">
					<?php echo $row->username?>
					</td>
					<td><?php echo $row->name . "(".$row->email.")";?></td>
					<?php if ($view_type == 1) { ?>
					<td align="center"><?php echo $row->ug_name;?></td>
					<td align="center"><?php echo $row->lms_usertype;?></td>
					<td align="center"><?php echo ($row->publish_start?JLMS_dateToDisplay($row->start_date):'-');?></td>
					<td align="center"><?php echo ($row->publish_end?JLMS_dateToDisplay($row->end_date):'-');?></td>
					<td><?php echo ($row->user_add_comment)?$row->user_add_comment:'&nbsp;';?></td>
					<?php } ?>
				</tr>
				<?php
				$k = 3 - $k;
			}?>
				</tbody>
				<tfoot><tr>
					<td colspan="<?php echo (($view_type == 1)?'10':'4');?>" align="center">
					<div class="pagination" align="center" style="white-space: nowrap;">
					<?php
					echo $pageNav->getPagesCounter();
					echo '<br />';
					echo $pageNav->writePagesLinks( $link ); ?>
					</div>
					</td>
				</tr></tfoot>
			</table>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="course_users" />
			<input type="hidden" name="group_id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="row_id" value="0" />
			<input type="hidden" name="state" value="0" />
			<input type="hidden" name="utype" value="<?php echo $view_type;?>" />
		</form>
<?php
	}

	static function showImportUsersCSV($option, $course_id, $group_id, $utype, $lists){
		global $Itemid;
		$JLMS_CONFIG = JLMSFactory::getConfig();
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		$form = JForm::getInstance('importusers', 'importusers');
		$form->bind(array('group_id' => $group_id));
		
		JHtml::_('behavior.formvalidation');		
		?>
<script language="javascript" type="text/javascript">
<!--
Joomla.submitbutton = function(task)
{
	var form = document.adminForm;
	
	if (task == 'cancel_user' || document.formvalidator.isValid(form)){
		<?php	
		echo $form->getField('teacher_comment')->save();
		?>
		Joomla.submitform(task, form);
	}
}
//-->
</script>
		<?php		
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => _JLMS_USER_IMPORT_TITLE, 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$toolbar->addSaveButton(array('href' => "javascript:Joomla.submitbutton('import_users');"));
		$toolbar->addCancelButton(array('href' => "javascript:Joomla.submitbutton('cancel_user');"));	
	
		echo $contentHeader;
		echo $toolbar;

		$groupField = $form->getField('group_id');		
		?>		
		<?php if ($utype == 1 && !$lists['disabled_import']) { ?>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid");?>" method="post" name="adminForm" enctype="multipart/form-data" class="form-validate">
			<div class="form-horizontal">
				<div class="row-fluid">
					<div class="control-group">
						<div class="control-label">
							<?php echo $form->getField('csv_file')->label; ?>
						</div>
						<div class="controls">
							<?php echo $form->getField('csv_file')->input; ?>
						</div>
					</div>
					<?php if(!$JLMS_CONFIG->get('use_global_groups', 1)) { ?>
					<div class="control-group">
						<div class="control-label">
							<?php echo $groupField->label; ?>
						</div>
						<div class="controls">
							<?php echo $groupField->input; ?>
						</div>
					</div>
					<?php } ?>
					<div class="control-group">
						<div class="control-label">
							<?php echo $form->getField('role_id')->label; ?>
						</div>
						<div class="controls">
							<?php echo $form->getField('role_id')->input; ?>
						</div>
					</div>
					<div class="control-group">
						<div class="control-label">
							<?php echo $form->getField('teacher_comment')->label; ?>
						</div>
						<div class="controls">
							<?php echo $form->getField('teacher_comment')->input; ?>
						</div>
					</div>				
				</div>
			</div>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="import_users" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
		</form>
		<?php
		}
	}
	
	static function addUser( $usrs, $option, $course_id, $group_id, $utype, $pageNav, $u_search, &$lists ) {
		global $Itemid, $JLMS_CONFIG;
			
		$user_data = new stdClass();
		
		if ($utype == 1) {			
			$is_lifetime = true;			
			$user_data->publish_start = 1;
			$user_data->publish_end = 0;
			$user_data->start_date = date('Y-m-d');
			$user_data->end_date = date('Y-m-d');
			
					
			$is_dis_start = !(isset($user_data->publish_start) && $user_data->publish_start == 1);
			$is_dis_end = !(isset($user_data->publish_end) && $user_data->publish_end == 1);
			
			JLMS_HTML::_('jlms_html.calendar.calendarextjs', $user_data->publish_start, $user_data->publish_end );		
			
			JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		
			$studentForm = JForm::getInstance('student', 'student');

			$studentForm->bind(array('role_id'=>($utype==1?2:4)));
		}	 
?>
<script language="javascript" type="text/javascript">
jQuery(function($) {				
	var sp2 =  $('.slide-panel-2'),
		sp3 =  $('.slide-panel-3');	
	
	sp2.hide();
	sp3.hide();
	
	$('#access_period_type').on('change', function(e) {
		var val = $(this).val();
		switch(parseInt(val)) {
			case 1:							
				if(sp2.is(':visible')) {
					sp2.slideToggle();
				}
				
				if(sp3.is(':visible')) {
					sp3.slideToggle();
				}
			break;
			case 2:
				if(sp3.is(':visible')) {
					sp3.slideToggle();
				}
				$('.slide-panel-2').slideToggle();
			break;
			case 3:
				if(sp2.is(':visible')) {
					sp2.slideToggle();
				}
				$('.slide-panel-3').slideToggle();
			break;
		
		}
	})
});

function submitbutton(pressbutton) {
	var form = document.adminForm;
	<?php	
	if ($utype == 1) {
		echo $studentForm->getField('teacher_comment')->save();
	}	
	?>
	try {
		form.onsubmit();
	} catch(e) {
		//alert(e);
	}
	var form2 = document.importForm;
	try {
		form2.onsubmit();
	} catch(e) {
		//alert(e);
	}
	if ((pressbutton == 'add_user_save') && (form.boxchecked.value == '0') ) {
		alert( "<?php echo _JLMS_USER_SELECT_USER;?>" );
	} else if ((pressbutton == 'import_users') && (form2.csv_file.value == '') ) {
		alert( "<?php echo _JLMS_SELECT_FILE;?>" );
	} else if((pressbutton == 'add_user_save') && form.role_id && form.role_id.value == '0'){
		alert( "<?php echo _JLMS_USERS_SELECT_ROLE;?>" );
		form.role_id.focus();
	} else {
		if (pressbutton == 'import_users') {
			form2.task.value = pressbutton;
			form2.submit();
		} else {
			form.task.value = pressbutton;
			form.submit();
		}
	}
}
function f_submitbutton(pressbutton){
	var form = document.filterForm;
	form.task.value = pressbutton;
	form.submit();	
}
</script>
<?php	
		$link = "index.php?option=$option&amp;Itemid=$Itemid&amp;task=add_user&amp;course_id=$course_id&amp;utype=$utype&amp;group_id=$group_id";
		if($u_search != ''){
			$link .= '&amp;u_search='.$u_search;
		}
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		
		$filtersForm = JForm::getInstance('filters', 'filters');
		
		$filtersForm->bind(array('u_search' => $u_search));		
		
		$contentHeader = new \LMS\Widgets\ContentHeader(array('title' => ($utype == 1)?_JLMS_USER_ADD_TITLE:_JLMS_USER_ASSIST_ADD_TITLE));
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$filters = new \LMS\Widgets\Filters();
		
		$toolbar->addSaveButton(array('href' => "javascript:submitbutton('add_user_save');"));
		$toolbar->addCancelButton(array('href' => "javascript:submitbutton('cancel_user');"));	
		
		ob_start();
		$pageNav->writeLimitBox( $link );
		$limitBox = ob_get_contents();
		ob_end_clean();
		
		$filters->addFilter($filtersForm->getField('u_search'));		
		$filters->addFilter($limitBox);		
				
		echo $contentHeader;
		echo $toolbar;		
?>		
		<form action="<?php echo sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid");?>" method="post" name="filterForm">
			<?php echo $filters; ?>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="id" value="0" />
			<input type="hidden" name="task" value="add_user" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="group_id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="utype" value="<?php echo $utype;?>" />
		</form>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid");?>" method="post" id="adminForm" name="adminForm">				
			<table width="100%" class="table table-striped table-hover">
				<tr>
					<th width="20">#</th>
					<th width="20">&nbsp;</th>
					<th width="15%" valign="middle">
						<?php echo _JLMS_USER_USERNAME;?>
					</th>
					<th width="15%" valign="middle">
						<?php echo _JLMS_USER_NAME;?>
					</th>
					<th valign="middle">
						<?php echo _JLMS_USER_EMAIL;?>
					</th>
				</tr>
				<?php
				for($i=0;$i<count($usrs);$i++){
				?>
				<tr>
					<td><?php echo ($pageNav->limitstart + $i + 1);?></td>
					<?php $checked = mosHTML::idBox( $i, $usrs[$i]->id); ?>
					<td><?php echo $checked;?></td>
					<td><?php echo $usrs[$i]->username?></td>
					<td><?php echo $usrs[$i]->name?></td>
					<td><?php echo $usrs[$i]->email?></td>
				</tr>
				<?php	
				}
				?>
				<tr>
					<td colspan="5" align="center">
						<div align="center" class="pagination">
						<?php							
							echo $pageNav->getPagesCounter();
							echo '<br />';
							echo $pageNav->writePagesLinks( $link );
						?>
						</div>
					</td>
				</tr>
			</table>
			<?php if($utype == 1) { ?>
			<h2><?php echo JText::_('_JLMS_ACCESS_PERIOD'); ?>:</h2>
			<div class="form-horizontal">
				<div class="row-fluid">					
						<div class="control-group">
							<div class="control-label">
								<?php echo $studentForm->getField('access_period_type')->label; ?>
							</div>
							<div class="controls">
								<?php echo $studentForm->getField('access_period_type')->input; ?>
							</div>
						</div>					
						<div class="control-group slide-panel-2">
							<div class="control-label">
								<?php echo JText::_('_JLMS_START_DATE');?>
							</div>							
							<div class="controls">	
								<input class="jlms_date_picker_check" type="checkbox" value="1" name="publish_start" onclick="jlms_Change_start()"<?php echo $user_data->publish_start?' checked="checked"':'';?> />
								<?php 									
									$s_date = ($is_dis_start)?date('Y-m-d'):$user_data->start_date;
									echo JLMS_HTML::_('calendar.calendar',$s_date,'start','start');
								?>								
							</div>
						</div>
						<div class="control-group slide-panel-2">
							<div class="control-label">
								<?php echo JText::_('_JLMS_END_DATE');?>
							</div>							
							<div class="controls">								
								<input class="jlms_date_picker_check" type="checkbox" value="1" name="publish_end" onclick="jlms_Change_end()"<?php echo $user_data->publish_end?' checked="checked"':'';?> />
								<?php 
									$e_date = ($is_dis_end)?date('Y-m-d'):$user_data->end_date;
									echo JLMS_HTML::_('calendar.calendar',$e_date,'end','end');
								?>
							</div>					
						</div>
						<script language="javascript" type="text/javascript">
							<?php if(!$user_data->publish_start) { ?>
								document.adminForm.startday.disabled = true;
								document.adminForm.startmonth.disabled = true;
								document.adminForm.startyear.disabled = true;
							<?php } ?>
							
							<?php if(!$user_data->publish_end) { ?>
								document.adminForm.endday.disabled = true;
								document.adminForm.endmonth.disabled = true;
								document.adminForm.endyear.disabled = true;	
							<?php } ?>
						</script>
						<div class="control-group slide-panel-3" >
							<div class="control-label">
								<?php echo JText::_('_JLMS_USERS_XDAYS_NUMBER');?>
							</div>							
							<div class="controls">								
								<input type="text" name="days_number" class="input-mini" value="" />
							</div>					
						</div>						
						<div class="control-group">
							<div class="control-label">
								<?php echo $studentForm->getField('teacher_comment')->label; ?>
							</div>
							<div class="controls">
								<?php echo $studentForm->getField('teacher_comment')->input; ?>
							</div>
						</div>
				</div>
			</div>
			<?php } ?>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="id" value="0" />
			<input type="hidden" name="task" value="add_user" />			
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="group_id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="utype" value="<?php echo $utype;?>" />
		</form>
<?php 
	}

	static function editUser( $user_data, $lists, $option, $course_id, $group_id ) {
		global $Itemid, $JLMS_CONFIG;
		
		$is_dis_start = !(isset($user_data->publish_start) && $user_data->publish_start == 1); 
		$is_dis_end = !(isset($user_data->publish_end) && $user_data->publish_end == 1);

		JLMS_HTML::_('jlms_html.calendar.calendarextjs', $user_data->publish_start, $user_data->publish_end );
		
		JForm::addFormPath(JPATH_COMPONENT.'/tools/users/models/forms/');
		
		$studentForm = JForm::getInstance('student', 'student');
		
		$studentForm->bind($user_data);		

		JHtml::_('behavior.formvalidation');		
		?>
<script language="javascript" type="text/javascript">
jQuery(function($) {				
	var sp2 =  $('.slide-panel-2'),
		sp3 =  $('.slide-panel-3');	
	<?php if($user_data->access_period_type != 2) { ?>
	sp2.hide();
	<?php } ?>
	sp3.hide();
	
	$('#access_period_type').on('change', function(e) {
		var val = $(this).val();
		switch(parseInt(val)) {
			case 1:							
				if(sp2.is(':visible')) {
					sp2.slideToggle();
				}
				
				if(sp3.is(':visible')) {
					sp3.slideToggle();
				}
			break;
			case 2:
				if(sp3.is(':visible')) {
					sp3.slideToggle();
				}
				$('.slide-panel-2').slideToggle();
			break;
			case 3:
				if(sp2.is(':visible')) {
					sp2.slideToggle();
				}
				$('.slide-panel-3').slideToggle();
			break;
		
		}
	})
});

Joomla.submitbutton = function(task)
{
	var form = document.adminForm;
	
	if (task == 'cancel_user' || document.formvalidator.isValid(form)){
		<?php	
		echo $studentForm->getField('teacher_comment')->save();
		?>
		Joomla.submitform(task, form);
	}
}
</script>
<?php
		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => _JLMS_USER_EDIT_TITLE, 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();		
		
		$toolbar->addSaveButton(array('href' => "javascript:Joomla.submitbutton('edit_user_save');"));
		$toolbar->addCancelButton(array('href' => "javascript:Joomla.submitbutton('cancel_user');"));		
		
		echo $contentHeader;
		echo $toolbar;
		
		$is_lifetime = (!$user_data->publish_start && !$user_data->publish_end);
?>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid");?>" method="post" name="adminForm" class="form-validate">			
			<div class="form-horizontal">
				<div class="row-fluid">						
						<div class="control-group">
							<div class="control-label">
								<?php echo _JLMS_USER_INFO;?>
							</div>
							<div class="controls">
								<?php echo $user_data->username.", ".$user_data->name." (".$user_data->email.")"; ?>
							</div>
						</div>	
						<div class="control-group">
							<div class="control-label">
								<?php echo $studentForm->getField('group_id')->label; ?>
							</div>
							<div class="controls">
								<?php echo $studentForm->getField('group_id')->input; ?>
							</div>
						</div>						
						<?php if( $user_data->value ) { ?>
						<div class="control-group">
							<div class="control-label">
								<?php echo _JLMS_ENROLL_TIME; ?>
							</div>
							<div class="controls">
								<?php JLMS_HTML::_('calendar.calendar',$user_data->enrol_time,'enrol_time','enrol_time', '%Y-%m-%d %H:%M'); ?> 
							</div>
						</div>
						<?php } ?>
						<div class="control-group">
							<div class="control-label">
								<?php echo $studentForm->getField('access_period_type')->label; ?>
							</div>
							<div class="controls">
								<?php echo $studentForm->getField('access_period_type')->input; ?>
							</div>
						</div>
						<div class="control-group slide-panel-2">
							<div class="control-label">
								<?php echo JText::_('_JLMS_START_DATE');?>
							</div>							
							<div class="controls">	
								<input class="jlms_date_picker_check" type="checkbox" value="1" name="publish_start" onclick="jlms_Change_start()"<?php echo $user_data->publish_start?' checked="checked"':'';?> />
								<?php 									
									$s_date = ($is_dis_start)?date('Y-m-d'):$user_data->start_date;									
									echo JLMS_HTML::_('calendar.calendar',$s_date,'start','start');
								?>								
							</div>
						</div>
						<div class="control-group slide-panel-2">
							<div class="control-label">
								<?php echo JText::_('_JLMS_END_DATE');?>
							</div>							
							<div class="controls">								
								<input class="jlms_date_picker_check" type="checkbox" value="1" name="publish_end" onclick="jlms_Change_end()"<?php echo $user_data->publish_end?' checked="checked"':'';?> />
								<?php 
									$e_date = ($is_dis_end)?date('Y-m-d'):$user_data->end_date;
									echo JLMS_HTML::_('calendar.calendar',$e_date,'end','end');
								?>
							</div>					
						</div>
						<script language="javascript" type="text/javascript">
							<?php if(!$user_data->publish_start) { ?>
								document.adminForm.startday.disabled = true;
								document.adminForm.startmonth.disabled = true;
								document.adminForm.startyear.disabled = true;
							<?php } ?>
							
							<?php if(!$user_data->publish_end) { ?>
								document.adminForm.endday.disabled = true;
								document.adminForm.endmonth.disabled = true;
								document.adminForm.endyear.disabled = true;	
							<?php } ?>
						</script>
						<div class="control-group slide-panel-3" >
							<div class="control-label">
								<?php echo JText::_('_JLMS_USERS_XDAYS_NUMBER');?>
							</div>							
							<div class="controls">								
								<input type="text" name="days_number" class="input-mini" value="" disabled="disabled" />
							</div>					
						</div>						
						<div class="control-group">
							<div class="control-label">
								<?php echo $studentForm->getField('teacher_comment')->label; ?>
							</div>
							<div class="controls">
								<?php echo $studentForm->getField('teacher_comment')->input; ?>
							</div>
						</div>
				</div>
			</div>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="add_user_save" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="user_id" value="<?php echo $user_data->value;?>" />
		</form>
	<?php
	}

	static function showImportLog( $import_log, $option, $course_id, $group_id ) {
		global $Itemid;

		$contentHeader	= new \LMS\Widgets\ContentHeader(array('title' => JText::_('_JLMS_USER_IMPORT_LOG_TITLE'), 'icon' => 'users_management'));
		$toolbar = new \LMS\Widgets\ContentToolbar();		
		
		$toolbar->addCancelButton(array('href' => JLMSRoute::_("index.php?option=$option&amp;Itemid=$Itemid&amp;task=view_users&amp;course_id=$course_id&amp;id=$group_id")));		
		
		echo $contentHeader;
		echo $toolbar;
?>
		<table width="100%" class="table table-striped table-hover">
			<tr>
				<th><?php echo _JLMS_USERS_TBL_HEAD_LOG_USER; ?></th>
				<th><?php echo _JLMS_USERS_TBL_HEAD_LOG_RESULT; ?></th>
			</tr>
			<?php foreach($import_log as $user_log) {
				echo "<tr><td>".$user_log->userinfo."</td><td>".$user_log->result."</td></tr>";
			} ?>
		</table>
<?php	
	}

	static function confirm_delUsers( &$del_users, &$lists, $option, $course_id, $group_id, $utype, $del_group ) {
		global $Itemid; ?>
		<script language="javascript" type="text/javascript">
		<!--
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if ((pressbutton == 'user_delete_yes') && (form.boxchecked.value == "0")){
				alert( "<?php echo _JLMS_USER_SELECT_USER;?>" );
			} else {
				form.task.value = pressbutton;
				form.submit();
			}
		}
		//-->
		</script>
		<?php
		$hparams = array();
		$message = '';
		
		if ($utype == 1) {
			$message = _JLMS_USERS_DEL_ALERT_MESSAGE;
		} elseif ($utype == 2) {
			$message = _JLMS_USERS_DEL_A_ALERT_MESSAGE;
		}
				
		$contentHeader = new \LMS\Widgets\ContentHeader(array('title' => _JLMS_USERS_DEL_TITLE, 'icon' => 'users_management'));
		$note = new \LMS\Widgets\Note(array('message' => $message, 'type' => 'warning'));
		$toolbar = new \LMS\Widgets\ContentToolbar();
		
		$toolbar->addDeleteButton(array('href' => "javascript:submitbutton('".($group_id == -1? 'user_delete_yes2': 'user_delete_yes')."');"));
		$toolbar->addCancelButton(array('href' => "javascript:submitbutton('".($group_id == -1? 'cancel_csv_delete': 'cancel_user')."');"));
	
		echo $contentHeader;
		echo $toolbar;
		echo $note;
		
		?>
		<form action="<?php echo sefRelToAbs("index.php?option=".$option."&amp;Itemid=".$Itemid);?>" method="post" id="adminForm" name="adminForm">
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover">
				<tr>
					<th width="20" align="center">#</th>
					<th width="1%" align="center"><input type="checkbox" name="toggle" value="" onclick="<?php echo JLMS_getCheckAll(count($del_users));?>" /></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USERNAME;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_ADDINFO;?></th>
					<th><?php echo _JLMS_USERS_TBL_HEAD_USER_GROUP;?></th>
				</tr>
			<?php
			$k = 1;
			for ($i=0, $n=count($del_users); $i < $n; $i++) {
				$row = $del_users[$i];
				$link 	= "index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=view_users&amp;course_id=".$course_id."&amp;id=". $row->id;
				$checked = mosHTML::idBox( $i, $row->id, false, 'cid', true); ?>
				<tr>
					<td align="center"><?php echo ( $i + 1 ); ?></td>
					<td><?php echo $checked; ?></td>
					<td align="left">
					<?php echo $row->username;?>
					</td>
					<td><?php echo $row->name;?> (<?php echo $row->email;?>)</td>
					<?php if ($utype == 1) { ?>
					<td><?php echo ($row->ug_name?$row->ug_name:_JLMS_USER_NO_GROUP_NAME);?></td>
					<?php } else { ?>
					<td><?php echo _JLMS_USER_ASSIST_GROUP_NAME;?></td>
					<?php } ?>
				</tr>
				<?php
				$k = 3 - $k;
			}?>
			</table>
			<input type="hidden" name="option" value="<?php echo $option;?>" />
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>" />
			<input type="hidden" name="task" value="delete_user" />
			<input type="hidden" name="course_id" value="<?php echo $course_id;?>" />
			<input type="hidden" name="id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="group_id" value="<?php echo $group_id;?>" />
			<input type="hidden" name="boxchecked" value="<?php echo count($del_users);?>" />
			<input type="hidden" name="row_id" value="0" />
			<input type="hidden" name="state" value="0" />
			<input type="hidden" name="del_group" value="<?php echo $del_group?'1':'0';?>" />
			<input type="hidden" name="utype" value="<?php echo $utype;?>" />
		</form>
	<?php		
	}
}
?>