<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace LMS\Tools\Conference\Repositories;

use LMS\Tools\Conference\Table;
use LMS\Libraries\Base;

class Test extends Base\Repository
{

    public function __construct($options)
    {
        parent::__construct($options);
		$this->table = new Table\Booking();
    }



	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->getTable()->getTableAlias();
		$query->select($alias.'.*');
		$query->where($alias . '.course_id = ' . $this->db->quote($filterOptions['booking.course_id']));
		return $query;
	}

}