<?php
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
?>
<div class="modalContainer">
	<h2><?php echo JText::_('_JLMS_MODULES')?></h2>
	<ul id="new-modules-list" class="list list-striped">
		<?php
		foreach ($this->items as &$item){
			// Prepare variables for the link.
			$link	= 'index.php?option=com_joomla_lms&task=coursebuilder.module.add';
			$link	.= '&course_id='. $this->state->get('courseId');
			$link	.= '&position='. $this->state->get('position');
			$link	.= '&jextid='. $item->extension_id;
			$link	.= '&Itemid='. $this->Itemid;

			$name	= $this->escape($item->name);
			$desc	= JHTML::_('string.truncate', ($this->escape($item->desc)), 200);
			$short_desc	= JHTML::_('string.truncate', ($this->escape($item->desc)), 100);
			?>
			<li>
				<a href="<?php echo JRoute::_($link);?>">
					<strong><?php echo $name; ?></strong>
				</a>
			</li>
			<?php
		}
		?>
	</ul>
	<div class="clr"></div>
</div>