<?php
namespace LMS\Tools\Courses\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Course extends Base\Controller
{
	protected $modelModule;
	
	public function __construct($config=array())
	{			
		parent::__construct($config);
	}
	
	public function save($config=array())
	{			
		$courseId = $this->config->get('course_id');
		
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms&id='.$courseId));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}					
		
		$data = $this->input->get('courseform', array(), 'array');
		$data['start_date'] = $this->input->getCmd('start_date', '', '');
		$data['end_date'] = $this->input->getCmd('end_date', '', '');
		$data['publish_start'] = isset($data['publish_start']);
		$data['publish_end'] = isset($data['publish_end']);		
		$redirect = $this->input->getVar('redirect', '');		
		$model = $this->getModel('Course');		
		
		$form = $model->getForm('Course');
		
		$data = $form->filter($data);				
		$model->save($data);
				
		$this->setRedirect(\JLMSRoute::_(base64_decode($redirect)));
	}	
}