<?php
namespace LMS\Tools\Subscriptions\View;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

defined('_JEXEC') or die;

class Subscription extends Base\View
{
	protected $extension = 'com_joomla_lms';
	
	protected $viewName = 'Subscription';	

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);		
	}
	
	public function edit()
	{	
		\JHtml::_('behavior.keepalive');
		\JHtml::_('behavior.formvalidation');

		$this->addScript('tools/subscriptions/assets/js/forms/subscription.js');
		
		$this->toolbar = $this->widget('contenttoolbar');		
		$this->toolbar->addCustomButton(array('title' => \JText::_('_JLMS_ADD'), 'click' => "submitSubscriptionForm('subscriptions.subscription.add');", 'class' => 'btn-success' ));
		
		$this->setLayout('edit');
	
		return parent::display();
	}
}