<?php

namespace LMS\Tools\Conference\Table;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class User extends Base\Table
{
	var $p_id = null;
	var $user_id = null;

	function __construct()
	{
		parent::__construct( '#__lms_conference_usr', 'id' );
		$this->relations = array(
			'profile' => array(
				'table' => ServiceLocator::get('userTable'),
				'type' => 'LEFT',
				'condition' => '{parent.user_id} = {child.id}',
				'capacity' => self::ONE
			),
		);
	}
}